/*
 * Generally useful stuff.
 */

#ifndef COMMON_H
#define COMMON_H

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <math.h>
#include <float.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define D3 3

double hypotD(const double p[D3], const double q[D3]);
double hypotD2(const double p[D3], const double q[D3]);
double hypotD2plus(const double p[D3], const double q[D3], double add);

double magnD(const double pq[D3]);
void xprod(double r[D3], const double a[D3], const double b[D3]);

#ifdef FP_FAST_FMA
# define fma_fast fma
#else
# define fma_fast(f1,f2,t) ((f1)*(f2)+(t))
#endif
#define ffsqa(factor,term) fma_fast((factor),(factor),(term))

#endif /*COMMON_H*/
